/**
 * Created by Ashild on 24.01.14.
 */

function Player(options){

    jaws.Sprite.call(this,{x:0,y:0, anchor:"center_bottom", width:30, height:45});

    _this = this;

    var player_width = 30;
    var player_height = 45;

    var spriteSheet = null;
    var start_position = {row:6, col:5};

    var blueAnimationFrames = null;
    var redAnimationFrames = null;
    var yellowAnimationFrames = null;
    var greyAnimationFrames = null;

    var greyFall = null;
    var redFall = null;
    var bluFall = null;
    var yellowFall = null;

    var currentAnimationFrames = null;
    var currentFallFrame = null;

    var xpos = 0;
    var ypos = 0;

    this.isFaling = false;
    this.isJumping = false;
    this.isOnFloor = false;

    this.left = false;
    this.right = false;

    var jumpTimer = 0;



    this.setup = function(){
        console.log("Player Setup");

        var frameDuration = 150;
        var sp = new jaws.SpriteSheet({ image: "img/player_spritesheet.png", anchor:"center_bottom", frame_size:[player_width,player_height] });
        blueAnimationFrames = new jaws.Animation({frames:sp.frames.slice(0,3), frame_duration:frameDuration});
        redAnimationFrames = new jaws.Animation({frames:sp.frames.slice(3,6), frame_duration:frameDuration});
        yellowAnimationFrames = new jaws.Animation({frames:sp.frames.slice(6,9), frame_duration:frameDuration});
        greyAnimationFrames = new jaws.Animation({frames:sp.frames.slice(9,12), frame_duration:frameDuration});

        currentAnimationFrames = greyAnimationFrames;

        greyFall = sp.frames[11];
        bluFall = sp.frames[1];
        redFall = sp.frames[5];
        yellowFall = sp.frames[8];

        currentFallFrame = greyFall;

        this.x = xpos = start_position.row * common.TILE_WIDTH;
        this.y = ypos = start_position.col * common.TILE_HEIGHT;

        jaws.on_keydown("up",function(){

            if(_this.isOnFloor){
                _this.isJumping = true;
                _this.isOnFloor = false;
                jumpTimer = 15;
            }

        });

        jaws.on_keydown("left",function(){

            if(_this.flipped){
                _this.flip();
            }
            _this.left = true;

        });

        jaws.on_keyup("left",function(){

            _this.left = false;

        })

        jaws.on_keydown("right",function(){

            _this.right = true;
            if(!_this.flipped){
                _this.flip();
            }

        });

        jaws.on_keyup("right",function(){

            _this.right = false;

        })

    };

    this.update = function(lvl){

        if(StatusBar.singelton.blueStatus){
            currentAnimationFrames = blueAnimationFrames;
            currentFallFrame = bluFall;
        }else if(StatusBar.singelton.redStatus){
            currentAnimationFrames = redAnimationFrames;
            currentFallFrame = redFall;
        } else if(StatusBar.singelton.yellowStatus){
            currentAnimationFrames = yellowAnimationFrames;
            currentFallFrame = yellowFall;
        }else if(currentAnimationFrames !== greyAnimationFrames){
            currentAnimationFrames = greyAnimationFrames;
            currentFallFrame = greyFall;
        }

        var nextFrame = currentAnimationFrames.next();

        var row = Math.round(this.y/ common.TILE_HEIGHT);
        var col = Math.round(this.x / common.TILE_WIDTH);

        if(!_this.isJumping && lvl.terain[row][col] == common.TERRAIN_AIR){
            _this.isFaling = true;
            _this.isOnFloor = false;
        }else if(!_this.isJumping){
            _this.isFaling = false;
            _this.isOnFloor = true;
            ypos = row * common.TILE_HEIGHT;
        }

        updateJumping();
        updateFaling();

        if(_this.right){
            xpos += 3;

        }
        if(_this.left){
            xpos -= 3;
        }

        if(!_this.isJumping && !_this.isFaling && (_this.right || _this.left)){
            this.setImage(nextFrame);
        }else{
            this.setImage(currentFallFrame);
        }

        _this.x = xpos;
        _this.y = ypos;

    }

    function updateJumping(){
        if(_this.isJumping){
            ypos -= 3;
            jumpTimer -= 1;
            if(jumpTimer == 0){
                _this.isJumping = false;
            }
        }
    }

    function updateFaling(){
        if(_this.isFaling){
            ypos = ypos + 3;
        }
    }

    this.setup();


}
