function gameScreen(){

    var GAME_STATES = {
                            IDLE:0,
                            INIT:10,
                            LOAD:20,
                            LOADING:21
                      };


    var currentGameState = GAME_STATES.IDLE;

    var availableLevels = null;
    var currentLevel = null;
    var currentLevelIndex = 0;

    var statusbar = null;
    var player = null;
    var background = null;

    var redCones = null;
    var blueCones = null;
    var yellowCones = null;
    var greyCones = null;

    this.setup = function(){
        console.log("Game Screen Setup");
        availableLevels = jaws.assets.get("data/levels.json").levels;
        console.log("Number of available levels :" + availableLevels.length);
        statusbar = new StatusBar();
        player = new Player();
        background = new Background();
        init();



    };

    function init(){
        console.log("Init Game");
        currentGameState = GAME_STATES.IDLE;
        jaws.context.fillStyle = "#B4D8E7";
        jaws.context.fillRect(0, 0, jaws.canvas.width, jaws.canvas.height);
        currentLevelIndex = 0;
        currentLevel = null;
        mapComponents = null;
        currentGameState = GAME_STATES.LOAD;
    }

    function loadLevel(){
        console.log("Load level " + nextLevel());
        currentGameState = GAME_STATES.IDLE;
        var gameData = jaws.assets.get(nextLevel());
        currentLevel = LevelFactory.CreateLevel(gameData);

        redCones = [];
        blueCones = [];
        yellowCones = [];
        greyCones = [];

        for(var row = 0; row < currentLevel.rows ; row++){
            for(var col = 0; col < currentLevel.columns; col++){
                if(currentLevel.cones[row][col] == common.CONE_BLUE){
                    blueCones.push(new jaws.Sprite({x: col * common.TILE_WIDTH, y: row * common.TILE_HEIGHT, image: "img/pine_cone_blue.png"}));
                }else if(currentLevel.cones[row][col] == common.CONE_RED){
                    redCones.push(new jaws.Sprite({x: col * common.TILE_WIDTH, y: row * common.TILE_HEIGHT, image: "img/pine_cone_red.png"}));
                }else if(currentLevel.cones[row][col] == common.CONE_YELLOW){
                    yellowCones.push(new jaws.Sprite({x: col * common.TILE_WIDTH, y: row * common.TILE_HEIGHT, image: "img/pine_cone_yellow.png"}));
                }else if(currentLevel.cones[row][col] == common.CONE_GREY){
                    greyCones.push(new jaws.Sprite({x: col * common.TILE_WIDTH, y: row * common.TILE_HEIGHT, image: "img/pine_cone_grey.png"}));
                }

                /*
                 if(currentLevel.cones[row][col] != common.CONE_AIR){
                 var colorKey = currentLevel.cones[row][col];
                 if(isColorEnabled(colorKey)){

                 //TODO: legge til kongle av riktig farge

                 jaws.context.fillStyle = "rgba(0, 255, 0, 1)"
                 jaws.context.fillRect(xpos,yPos,common.TILE_WIDTH, common.TILE_HEIGHT);
                 }
                 }
                 */
            }
        }

        //cones end
    }

    function colorForTerain(terain){
        switch (terain){
            case common.TERRAIN_BLUE : return common.COLOR_BLUE.hex;
            case common.TERRAIN_YELLOW : return common.COLOR_YELLOW.hex;
            case common.TERRAIN_RED : return common.COLOR_RED.hex;
            case common.TERRAIN_BLACK: return common.COLOR_GREY_TILES.hex;
            case common.TERRAIN_AIR: return "rgba(0, 0, 0, 0.0)";
        }
    }

    function nextLevel(){
        return availableLevels[currentLevelIndex];
    }

    this.update = function(){

        switch (currentGameState){
            case GAME_STATES.INIT:  init();
                                    break;

            case GAME_STATES.LOAD:  loadLevel();
                                    break;

        }

        if(player){
            player.update(currentLevel);
        }
    };

    function isColorEnabled(color){
        if(color == common.TERRAIN_BLACK){
            return statusbar.greyStatus;
        }
        else if(color == common.TERRAIN_BLUE){
            return statusbar.blueStatus;
        }
        else if(color == common.TERRAIN_RED){
            return statusbar.redStatus;
        }else if(color == common.TERRAIN_YELLOW){
            return statusbar.yellowStatus;
        }
        return false;
    }

    this.draw =function(){

        jaws.clear();

        background.draw();

        var xpos = 0;
        var yPos = 0;
        if(currentLevel != null){
            for(var row = 0; row < currentLevel.rows ; row++){

                for(var col = 0; col < currentLevel.columns; col++){
                    if(currentLevel.terain[row][col] != common.TERRAIN_AIR){
                        var colorKey = currentLevel.terain[row][col];
                        if(isColorEnabled(colorKey)){
                            jaws.context.fillStyle = colorForTerain(colorKey);
                            jaws.context.fillRect(xpos,yPos,common.TILE_WIDTH, common.TILE_HEIGHT);
                        }
                    }
                    xpos += common.TILE_WIDTH;
                }
                xpos = 0;
                yPos += common.TILE_HEIGHT
            }
        }

        //cones

        ///TODO: if Rød tilgjengelig
        for(var i = 0; i < redCones.length ; i++){
            redCones[i].draw();
        }
        ///TODO: if gul tilgjengelig
        for(var i = 0; i < yellowCones.length ; i++){
            yellowCones[i].draw();
        }
        ///TODO: if blå tilgjengelig
        for(var i = 0; i < blueCones.length ; i++){
            blueCones[i].draw();
        }
        ///TODO: if blå tilgjengelig
        for(var i = 0; i < greyCones.length ; i++){
            greyCones[i].draw();
        }
        //cones end


        player.draw();

        statusbar.draw();

    };

    this.exit = function(){

    }
}