function MenuScreen(){

    var _this = this;

    var background = null;
    var logo = null;
    var interval = null;
    var current_selected_menuitem = 0;

    var position_play_btn = {row:6, col:2};
    var position_settings_btn = {row:10, col:13};
    var position_credits_btn = {row:5, col:24};

    var menu = [
        {item:null, active:null, name:"Play", action:"PlayGame", image:"img/btn_yellow.png", image_selected:"img/btn_yellow_selected.png",
            x: position_play_btn.col * common.TILE_WIDTH, y: position_play_btn.row * common.TILE_HEIGHT},
        {item:null, active:null, name:"Settings", action:"ChangeSettings", image:"img/btn_red.png", image_selected:"img/btn_red_selected.png",
            x: position_settings_btn.col * common.TILE_WIDTH, y: position_settings_btn.row * common.TILE_HEIGHT},
        {item:null, active:null, name:"Credits", action:"ShowCredits", image:"img/btn_blue.png", image_selected:"img/btn_blue_selected.png",
            x: position_credits_btn.col * common.TILE_WIDTH, y: position_credits_btn.row * common.TILE_HEIGHT}
    ];

    this.setup = function(){
        console.log("Menu Screen Setup");

        //TODO: generere bakgunn
        background = new jaws.Sprite({x: 0, y: 0, image: "img/menybg.png"});

        ///TODO: lage varialbler for dette, slik at logo havner på midten..
        logo = new jaws.Sprite({x: 0, y: 50, image:"img/logo.png"});
        logo.x = common.STAGE_WIDTH / 2 - logo.width / 2;

        for(var i = 0; i < menu.length; i++){
            menu[i].item = new jaws.Sprite({x: menu[i].x, y: menu[i].y, image:menu[i].image});
            menu[i].selected = new jaws.Sprite({x: menu[i].x, y: menu[i].y, image:menu[i].image_selected});
        }

        setupKeyboard();
        setupMouse();

    };

    function setupMouse(){
        ///TODO: overvåke mus og knapper.
    }

    function setupKeyboard(){
        jaws.on_keydown(["down","s","right"],function(){
            current_selected_menuitem++;
            if(current_selected_menuitem >= menu.length){
                current_selected_menuitem = 0;
            }
        });

        jaws.on_keydown(["up","w", "left"],function() {
            current_selected_menuitem--;
            if(current_selected_menuitem < 0) {
                current_selected_menuitem = menu.length -1;
            }
        });

        jaws.on_keydown(["enter","space"],function(){
            if(current_selected_menuitem == 0) {
                _this.PlayGame();
            }else if(current_selected_menuitem == 1){
                _this.ChangeSettings();
            }else if(current_selected_menuitem == 2){
                _this.ShowCredits();
            }
        });
    }

    this.update = function(){

    }

    this.draw =function(){
        background.draw();

        logo.draw();

        for(var i = 0; i < menu.length; i++){

            if(i == current_selected_menuitem){
                menu[i].selected.draw();
            }else{
                menu[i].item.draw();
            }
        }
    };

    this.exit = function(){

    }

    // -------------------------------------------------------------------------------------------------------------- //

    this.PlayGame = function(){
        console.log("Menu Play Game Button pressed");
        jaws.switchGameState(gameScreen);

    }

    this.ChangeSettings = function(){
        console.log("Menu Change Settings Button pressed");
        jaws.switchGameState(/*TODO*/);
    }

    this.ShowCredits = function(){
        console.log("Menu Show credits Button pressed");
        jaws.switchGameState(/*TODO*/);
    }

}