function StatusBar(options){

//    jaws.Sprite.call(this, options);

    var _this = this;

    if(StatusBar.singelton == null)
        StatusBar.singelton = _this;

    var current_selected_color = 0;

    var position_blue = {row:1, col:2};
    var position_red = {row:1, col:4};
    var position_yellow = {row:1, col:6};

    var colors = [
        {item:null, selected:null, image:"img/status_blue.png", image_selected:"img/status_blue_selected.png",
            x: position_blue.col * common.TILE_WIDTH, y: position_blue.row * common.TILE_HEIGHT},
        {item:null, selected:null, image:"img/status_red.png", image_selected:"img/status_red_selected.png",
            x: position_red.col * common.TILE_WIDTH, y: position_red.row * common.TILE_HEIGHT},
        {item:null, selected:null, image:"img/status_yellow.png", image_selected:"img/status_yellow_selected.png",
            x: position_yellow.col * common.TILE_WIDTH, y: position_yellow.row * common.TILE_HEIGHT}
    ];

    this.yellowStatus = false;
    this.redStatus = false;
    this.blueStatus = false;
    this.greyStatus = true;

    this.changed = true;

    this.setup = function(){
        console.log("Statusbar Setup");

        for(var i = 0; i < colors.length; i++){
            colors[i].item = new jaws.Sprite({x: colors[i].x, y: colors[i].y, image:colors[i].image});
            colors[i].selected = new jaws.Sprite({x: colors[i].x, y: colors[i].y, image:colors[i].image_selected});
        }

        setupKeyboard();

    };

    function setupKeyboard(){

        jaws.on_keydown(["1"],function(){
           _this.blueStatus = !_this.blueStatus;
            if(_this.blueStatus){
                _this.redStatus = false;
                _this.yellowStatus = false;
            }
            _this.changed = true;
        });


        jaws.on_keydown(["2"],function(){
            _this.redStatus = !_this.redStatus;
            if(_this.redStatus){
                _this.blueStatus = false;
                _this.yellowStatus = false;
            }
            _this.changed = true;
        });

        jaws.on_keydown(["3"],function(){
            _this.yellowStatus = !_this.yellowStatus;
            if(_this.yellowStatus){
                _this.blueStatus = false;
                _this.redStatus = false;
            }
            _this.changed = true;
        });


    }

    this.update = function(){

    }

    this.draw =function(){

        _this.blueStatus ? colors[0].selected.draw():colors[0].item.draw();
        _this.redStatus ? colors[1].selected.draw():colors[1].item.draw();
        _this.yellowStatus ? colors[2].selected.draw():colors[2].item.draw();

    };

    this.exit = function(){

    }

    this.setup();
}

StatusBar.singelton = null;